// Item 18: Make interfaces easy to use correctly and hard to use incorrectly.  78


struct M {
	explicit M(int m) : val(m){}
	int val;
};

struct D {
	explicit D(int d) : val(d){}
	int val;
};

struct Y {
	explicit Y(int y) : val(y){}
	int val;
};

class Date {
public:
	Date( const M& m, const D& d, const Y& y );
};


// bad

struct M {
	explicit M(int m) {}
	int val;
};

struct D {
	explicit D(int d) {}
	int val;
};

struct Y {
	explicit Y(int y) {}
	int val;
};

class Date {
public:
	Date( const M& m, const D& d, const Y& y );
};